# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2007,2009 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# boolean _bool(anytype arg1)
#
# Return _TRUE if either "arg1" is set to "true", "yes", "y" or "on"
# (all case-insensitive), or if its numeric casting evaluates to '1';
# otherwise return _FALSE .
# =====================================================================

function _bool(arg1) {

  if ((arg1=_strip(tolower(arg1))) == "true" || arg1 == "yes" ||\
	 arg1 == "y" || arg1 == "on" || (arg1/1) == 1) return _TRUE
  else return _FALSE
}

