# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001-2016 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# string _escreg(string re)
#
# Escape special characters in a string that is to be used as an AWK
# regular expression.
# =====================================================================

function _escreg(re) {

  # Escape backslashes first ...
  #gsub(/\\/,"&&", re)

  # ... then all other special characters.
  #gsub(/\$/, "\\$", re)
  #gsub(/\(/, "\\(", re)
  #gsub(/\)/, "\\)", re)
  #gsub(/\[/, "\\[", re)
  #gsub(/\]/, "\\]", re)
  #gsub(/\|/, "\\|", re)
  #gsub(/\^/, "\\^", re)
  #gsub(/\*/, "\\*", re)
  #gsub(/\?/, "\\?", re)
  #gsub(/\./, "\\.", re)

  # A probably faster alternative.

  gsub(/[]\\\$()\[\|\^\*\?\.]/,"\\\\&",re)

  # The '&' character is likely missing from the list of those
  # that are to be escaped. I only recently realized this but
  # I will not enable it for the moment, until I'm sure that
  # adding it does not introduce backward-compatibility issues.
  #
  #gsub(/[]\\\$()\[\|\^\*\?\.&]/,"\\\\&",re)

  return re
}

