# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2006,2007,2008,2009,2010 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# boolean _isipaddr(string ip)
#
# Return _TRUE if the received string is a sintactically valid IPv4
# or IPv6 network address, or _FALSE otherwise.
# =====================================================================

function _isipaddr(ip,		i,a) {

  # IPv4 section.

  if ((i=split(ip, a, ".")) > 1) {

     if (i != 4)  return _FALSE

     while (i) {
       if (a[i]"" !~ /^[0-9]+$/ || \
	   length(a[i]) > 3 || a[i]/1 > 255) return _FALSE
       i--
     }

     return _TRUE
  }

  # IPv6 section.

  if ((i=split(ip, a, ":")) < 3 || i > 8)  return _FALSE

  while (i) {
    if (a[i]"" !~ /^[a-f0-9]*$/ || length(a[i]) > 4) return _FALSE
    i--
  }

  return _TRUE
}
