# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2007 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================

function _pathinfo(map,		pathinfo,rec,restmap,found,a,i,verb) {

   # Set value of the REST "verb".
   verb = ENVIRON["REQUEST_METHOD"]

   pathinfo = _uriencode(ENVIRON["PATH_INFO"])

   # Un-encode selected characters, namely "/", "-", "_"
   # and ";" to allow for rewriting rules that are more
   # intelligible and a bit more selective.

   gsub(/%2[Ff]/,"/",pathinfo)
   gsub(/%2[Dd]/,"-",pathinfo)
   gsub(/%3[Bb]/,";",pathinfo)
   gsub(/%5[Ff]/,"_",pathinfo)

   # Load the REST map file, if available. Skip comments and
   # empty lines along the way.

   i=0;
   while (getline rec < map > 0) {

       # *must* remove leading spaces.
       sub(/^[ \t]*/, "", rec)

       # skip comments and empty lines.
       if (rec ~ /^(#|$)/) continue

       restmap[++i] = rec
   }

   if (close(map)) return		# ignore non-existent map file

   restmap[0] = i			# Set array size.

   found = i = 0
   while (++i <= restmap[0]) {

       # skip bogus lines.
       if (split(restmap[i], a, "[ \t]+") < 2) continue

       if (found && a[1] != "+") break			# bail-out
       else if (found && a[1] == "+") {
	  # if (a[3] != "") sub(a[2], a[3], ENVIRON["PATH_INFO"])
	  sub(a[2], a[3], ENVIRON["PATH_INFO"])
	  continue
       }
       else if (a[1] != "+") {
	  found = 0
	  # Accepting GET always implies accepting also HEAD.
	  if (a[1] ~ /GET/ && a[1] !~ /HEAD/)
				sub("GET","(GET|HEAD)",a[1])
	  if (verb ~ a[1] && pathinfo ~ a[2]) {
	     if (a[3] != "") sub(a[2], a[3], ENVIRON["PATH_INFO"])
	     found=1
	  }
       }
   }

   # Turn "/class.method" into "/class/method", so that both forms
   # are supported in the URI. This must come *after* the rewriting
   # rules, if any, have been applied.

   #if (ENVIRON["PATH_INFO"] ~ /^\/[^\/]+\.[^\/]+\/?/)
   if (ENVIRON["PATH_INFO"] ~ /^\/[a-zA-Z0-9][-_:a-zA-Z0-9]*\.[^\/]+\/?/)
			sub(/\./, "/", ENVIRON["PATH_INFO"])

   split(ENVIRON["PATH_INFO"], a, "/")

   # Note that this function is able to return the correct application
   # name even if there was no match in the site-wide REST map file,
   # provided that the application name appears verbatim at the
   # beginning of the original URL that is to be rewritten. This is why
   # there can be no match in the site-wide map, and still no application
   # name is needed in the application-level rewriting rules.

   if (a[2] ~ /^[a-zA-Z0-9][-_:a-zA-Z0-9]*$/) return a[2]
}

