# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2006,2010 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _sort.awk 72 2010-09-13 16:09:57Z carlo $
# =====================================================================
# void _sort(array array, int elements [, boolean fold])
#
# Sort array elements. The passed array is modified due to reordering.
# If "fold" is specified then sorting is done case-insensitively.
#
# Note: how elements are actually sorted on some systems may depend
# also on the locale settings.
# =====================================================================

function _sort(a,e,fold,			tmp,i,j) {

   if (fold) {
      for (i=2; i <= e; ++i) {
	  for (j=i; tolower(a[j-1]) > tolower(a[j]); --j) {
	      tmp = a[j]
	      a[j] = a[j-1]
	      a[j-1] = tmp
	  }
      }
   }
   else {
      for (i=2; i <= e; ++i) {
	  for (j=i; a[j-1] > a[j]; --j) {
	      tmp = a[j]
	      a[j] = a[j-1]
	      a[j-1] = tmp
	  }
      }
   }
   return
}
