# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _stat.awk 43 2007-09-24 08:30:21Z carlo $
# =====================================================================
# stat(2): int _stat(string file)
#
# Returns _EINVAL if no arg, 0 if file exists (can be a hard/symbolic
# link) and is readable, _EISDIR if file is a directory, _ENOENT if file
# doesn't exist.
# =====================================================================

function _stat(file,	rc) {

   if (file == "") return _EINVAL
   if ((rc = (getline < file)) >= 0) { close(file); return 0 }
   if (rc == 2) return _EISDIR
   else if (rc == 255) return _ENOENT
   else return _EIO		      # Unknown code, assume I/O error.
}

