# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2006,2010 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _uniq.awk 72 2010-09-13 16:09:57Z carlo $
# =====================================================================
# int _uniq(array array, int elements [, boolean fold])
#
# Remove duplicated entries from a sorted array and return the new array
# length. The received array is modified due to pruning. If "fold" is
# specified then comparisons are done case-insensitively.
# =====================================================================

function _uniq(a,e,fold,			b,i,j) {

   while (++i <= e) b[i] = a[i]		# copy array to workarea.
   j=1
   if (fold) {
      for (i=2; i <= e; ++i)
		if (tolower(b[i]) != tolower(b[i-1])) a[++j] = b[i]
   }
   else {
      for (i=2; i <= e; ++i)
		if (b[i] != b[i-1]) a[++j] = b[i]
   }
   return j
}
