/* csa-space: turns a compact string into a spaced list of characters.

   Copyright (c) 2001,2010 Carlo Strozzi

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


   Usage:  csa-space string [length]

   Examples:

   $ csa-space abcd
   a b c d

   $ csa-space abcd 2
   a b


 ****************************************************************************/

static char Psz_RCS[] = "$Date: 2006/03/10 21:36:17 $";

#include <stdio.h>
#include <stdlib.h>

/****************************************************************************/
/*                                  main ()                                 */
/****************************************************************************/
int main(int argc, char **argv) {

   int    i=0, n=0;

   if (argc < 2 || argc > 3) {
      fprintf( stderr, "usage: csa-space string [n]\n" );
      exit(1);
   }

   if (argc == 3) n = atoi(argv[2]);

   while (argv[1][0]) {
      if (argv[1][0] != ' ' && argv[1][0] != '\t') {
      	 if (i++) printf(" ");

	 /* Account for UTF-8 characters here */
	 if (!isascii(argv[1][0])) {
	    printf("%c", argv[1][0]);
	    argv[1]++;
	 }

      	 printf("%c", argv[1][0]);
	 if (n && i >= n) break;
      }
      argv[1]++;
   }

   printf("\n");

   exit(0);
}

/* End of program */
